using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Routing;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.JsonPatch;
using Microsoft.EntityFrameworkCore;
using Microsoft.Extensions.Logging;

using AyaNova.Models;
using AyaNova.Api.ControllerHelpers;
using AyaNova.Biz;


namespace AyaNova.Api.Controllers
{
    //DOCUMENTATING THE API
    //https://docs.microsoft.com/en-us/dotnet/csharp/programming-guide/xmldoc/recommended-tags-for-documentation-comments
    //https://github.com/domaindrivendev/Swashbuckle.AspNetCore#include-descriptions-from-xml-comments

    /// <summary>
    /// Sample controller class used during development for testing purposes
    /// </summary>
    [ApiVersion("8.0")]
    [Route("api/v{version:apiVersion}/[controller]")]
    [Produces("application/json")]
    [Authorize]
    public class WidgetController : Controller
    {
        private readonly AyContext ct;
        private readonly ILogger<WidgetController> log;
        private readonly ApiServerState serverState;


        /// <summary>
        /// ctor
        /// </summary>
        /// <param name="dbcontext"></param>
        /// <param name="logger"></param>
        /// <param name="apiServerState"></param>  
        public WidgetController(AyContext dbcontext, ILogger<WidgetController> logger, ApiServerState apiServerState)
        {
            ct = dbcontext;
            log = logger;
            serverState = apiServerState;
        }


        /// <summary>
        /// Get full widget object
        /// 
        /// Required roles:
        /// BizAdminFull, InventoryFull, BizAdminLimited, InventoryLimited, TechFull, TechLimited, Accounting
        /// </summary>
        /// <param name="id"></param>
        /// <returns>A single widget</returns>
        [HttpGet("{id}")]
        public async Task<IActionResult> GetWidget([FromRoute] long id)
        {
            if (serverState.IsClosed)
                return StatusCode(503, new ApiErrorResponse(ApiErrorCode.API_CLOSED, null, serverState.Reason));

            //Instantiate the business object handler
            WidgetBiz biz = WidgetBiz.GetBiz(ct, HttpContext);

            if (!Authorized.IsAuthorizedToReadFullRecord(HttpContext.Items, biz.BizType))
                return StatusCode(401, new ApiNotAuthorizedResponse());

            if (!ModelState.IsValid)
                return BadRequest(new ApiErrorResponse(ModelState));

            var o = await biz.GetAsync(id);
            if (o == null)
                return NotFound(new ApiErrorResponse(ApiErrorCode.NOT_FOUND));

            return Ok(new ApiOkResponse(o));
        }


        /// <summary>    
        /// Get filter and sort options
        /// 
        /// Required roles: 
        /// BizAdminFull, InventoryFull, BizAdminLimited, InventoryLimited, TechFull, TechLimited, Accounting
        /// 
        /// </summary>
        /// <returns>Filter options</returns>    
        [HttpGet("FilterOptions")]
        public ActionResult FilterOptions()
        {
            if (serverState.IsClosed)
                return StatusCode(503, new ApiErrorResponse(ApiErrorCode.API_CLOSED, null, serverState.Reason));

            //Instantiate the business object handler
            WidgetBiz biz = WidgetBiz.GetBiz(ct, HttpContext);

            if (!Authorized.IsAuthorizedToReadFullRecord(HttpContext.Items, biz.BizType))
                return StatusCode(401, new ApiNotAuthorizedResponse());

            return Ok(new
            {
                data = WidgetBiz.FilterOptions(biz.UserLocaleId)
            });
        }


        /// <summary>
        /// Get paged list of widgets
        /// 
        /// Required roles: 
        ///  BizAdminFull, InventoryFull, BizAdminLimited, InventoryLimited, TechFull, TechLimited, Accounting
        /// </summary>
        /// <returns>Paged collection of widgets with paging data</returns>            
        [HttpGet("ListWidgets", Name = nameof(ListWidgets))]//We MUST have a "Name" defined or we can't get the link for the pagination, non paged urls don't need a name
        public async Task<IActionResult> ListWidgets([FromQuery] PagingOptions pagingOptions)
        {
            if (serverState.IsClosed)
                return StatusCode(503, new ApiErrorResponse(ApiErrorCode.API_CLOSED, null, serverState.Reason));

            //Instantiate the business object handler
            WidgetBiz biz = WidgetBiz.GetBiz(ct, HttpContext);

            if (!Authorized.IsAuthorizedToReadFullRecord(HttpContext.Items, biz.BizType))
                return StatusCode(401, new ApiNotAuthorizedResponse());

            if (!ModelState.IsValid)
                return BadRequest(new ApiErrorResponse(ModelState));

            ApiPagedResponse<Widget> pr = await biz.GetManyAsync(Url, nameof(ListWidgets), pagingOptions);
            return Ok(new ApiOkWithPagingResponse<Widget>(pr));
        }



        // /// <summary>
        // /// Get widget pick list
        // /// 
        // /// Required roles: Any
        // /// 
        // /// This list supports querying the Name property
        // /// include a "q" parameter for string to search for 
        // /// use % for wildcards.
        // /// 
        // /// e.g. q=%Jones%
        // /// 
        // /// Query is case insensitive
        // /// </summary>
        // /// <returns>Paged id/name collection of widgets with paging data</returns>    
        // [HttpGet("PickList", Name = nameof(WidgetPickList))]
        // public async Task<IActionResult> WidgetPickList([FromQuery] string q, [FromQuery] PagingOptions pagingOptions)
        // {
        //     if (serverState.IsClosed)
        //         return StatusCode(503, new ApiErrorResponse(ApiErrorCode.API_CLOSED, null, serverState.Reason));

        //     if (!ModelState.IsValid)
        //         return BadRequest(new ApiErrorResponse(ModelState));

        //     //Instantiate the business object handler
        //     WidgetBiz biz = WidgetBiz.GetBiz(ct, HttpContext);

        //     ApiPagedResponse<NameIdItem> pr = await biz.GetPickListAsync(Url, nameof(WidgetPickList), pagingOptions, q);
        //     return Ok(new ApiOkWithPagingResponse<NameIdItem>(pr));
        // }

         /// <summary>
        /// Get widget pick list
        /// 
        /// Required roles: Any
        /// 
        /// This list supports querying the Name property
        /// include a "q" parameter for string to search for 
        /// use % for wildcards.
        /// 
        /// e.g. q=%Jones%
        /// 
        /// Query is case insensitive
        /// </summary>
        /// <returns>Paged id/name collection of widgets with paging data</returns>    
        [HttpGet("PickList", Name = nameof(WidgetPickList))]
        public async Task<IActionResult> WidgetPickList([FromQuery] PagingOptions pagingOptions)
        {
            if (serverState.IsClosed)
                return StatusCode(503, new ApiErrorResponse(ApiErrorCode.API_CLOSED, null, serverState.Reason));

            if (!ModelState.IsValid)
                return BadRequest(new ApiErrorResponse(ModelState));

            //Instantiate the business object handler
            WidgetBiz biz = WidgetBiz.GetBiz(ct, HttpContext);

            ApiPagedResponse<NameIdItem> pr = await biz.GetPickListAsync(Url, nameof(WidgetPickList), pagingOptions);
            return Ok(new ApiOkWithPagingResponse<NameIdItem>(pr));
        }


        /// <summary>
        /// Put (update) widget
        /// 
        /// Required roles:
        /// BizAdminFull, InventoryFull
        /// TechFull (owned only)
        /// 
        /// </summary>
        /// <param name="id"></param>
        /// <param name="inObj"></param>
        /// <returns></returns>
        [HttpPut("{id}")]
        public async Task<IActionResult> PutWidget([FromRoute] long id, [FromBody] Widget inObj)
        {
            if (!serverState.IsOpen)
                return StatusCode(503, new ApiErrorResponse(ApiErrorCode.API_CLOSED, null, serverState.Reason));

            if (!ModelState.IsValid)
                return BadRequest(new ApiErrorResponse(ModelState));

            //Instantiate the business object handler       
            WidgetBiz biz = WidgetBiz.GetBiz(ct, HttpContext);

            var o = await biz.GetNoLogAsync(id);
            if (o == null)
                return NotFound(new ApiErrorResponse(ApiErrorCode.NOT_FOUND));

            if (!Authorized.IsAuthorizedToModify(HttpContext.Items, biz.BizType, o.OwnerId))
                return StatusCode(401, new ApiNotAuthorizedResponse());

            try
            {
                if (!biz.Put(o, inObj))
                    return BadRequest(new ApiErrorResponse(biz.Errors));
            }
            catch (DbUpdateConcurrencyException)
            {
                if (!await biz.ExistsAsync(id))
                    return NotFound(new ApiErrorResponse(ApiErrorCode.NOT_FOUND));
                else
                    return StatusCode(409, new ApiErrorResponse(ApiErrorCode.CONCURRENCY_CONFLICT));
            }
            return Ok(new ApiOkResponse(new { ConcurrencyToken = o.ConcurrencyToken }));
        }



        /// <summary>
        /// Patch (update) widget
        /// 
        /// Required roles:
        /// BizAdminFull, InventoryFull
        /// TechFull (owned only)
        /// </summary>
        /// <param name="id"></param>
        /// <param name="concurrencyToken"></param>
        /// <param name="objectPatch"></param>
        /// <returns></returns>
        [HttpPatch("{id}/{concurrencyToken}")]
        public async Task<IActionResult> PatchWidget([FromRoute] long id, [FromRoute] uint concurrencyToken, [FromBody]JsonPatchDocument<Widget> objectPatch)
        {
            //https://dotnetcoretutorials.com/2017/11/29/json-patch-asp-net-core/

            if (!serverState.IsOpen)
                return StatusCode(503, new ApiErrorResponse(ApiErrorCode.API_CLOSED, null, serverState.Reason));

            if (!ModelState.IsValid)
                return BadRequest(new ApiErrorResponse(ModelState));

            //Instantiate the business object handler
            WidgetBiz biz = WidgetBiz.GetBiz(ct, HttpContext);

            var o = await biz.GetNoLogAsync(id);
            if (o == null)
                return NotFound(new ApiErrorResponse(ApiErrorCode.NOT_FOUND));

            if (!Authorized.IsAuthorizedToModify(HttpContext.Items, biz.BizType, o.OwnerId))
                return StatusCode(401, new ApiNotAuthorizedResponse());

            try
            {
                //patch and validate
                if (!biz.Patch(o, objectPatch, concurrencyToken))
                    return BadRequest(new ApiErrorResponse(biz.Errors));
            }
            catch (DbUpdateConcurrencyException)
            {
                if (!await biz.ExistsAsync(id))
                    return NotFound(new ApiErrorResponse(ApiErrorCode.NOT_FOUND));
                else
                    return StatusCode(409, new ApiErrorResponse(ApiErrorCode.CONCURRENCY_CONFLICT));
            }
            return Ok(new ApiOkResponse(new { ConcurrencyToken = o.ConcurrencyToken }));
        }


        /// <summary>
        /// Post widget
        /// 
        /// Required roles: 
        /// BizAdminFull, InventoryFull, TechFull
        /// </summary>
        /// <param name="inObj"></param>
        /// <returns></returns>
        [HttpPost]
        public async Task<IActionResult> PostWidget([FromBody] Widget inObj)
        {
            if (!serverState.IsOpen)
                return StatusCode(503, new ApiErrorResponse(ApiErrorCode.API_CLOSED, null, serverState.Reason));

            //Instantiate the business object handler
            WidgetBiz biz = WidgetBiz.GetBiz(ct, HttpContext);

            //If a user has change roles, or editOwnRoles then they can create, true is passed for isOwner since they are creating so by definition the owner
            if (!Authorized.IsAuthorizedToCreate(HttpContext.Items, biz.BizType))
                return StatusCode(401, new ApiNotAuthorizedResponse());

            if (!ModelState.IsValid)
                return BadRequest(new ApiErrorResponse(ModelState));

            //Create and validate
            Widget o = await biz.CreateAsync(inObj);
            if (o == null)
                return BadRequest(new ApiErrorResponse(biz.Errors));
            else
                return CreatedAtAction("GetWidget", new { id = o.Id }, new ApiCreatedResponse(o));

        }



        /// <summary>
        /// Delete widget
        /// 
        /// Required roles:
        /// BizAdminFull, InventoryFull
        /// TechFull (owned only)
        /// 
        /// </summary>
        /// <param name="id"></param>
        /// <returns>Ok</returns>
        [HttpDelete("{id}")]
        public async Task<IActionResult> DeleteWidget([FromRoute] long id)
        {
            if (!serverState.IsOpen)
                return StatusCode(503, new ApiErrorResponse(ApiErrorCode.API_CLOSED, null, serverState.Reason));

            if (!ModelState.IsValid)
                return BadRequest(new ApiErrorResponse(ModelState));

            //Instantiate the business object handler
            WidgetBiz biz = WidgetBiz.GetBiz(ct, HttpContext);

            var o = await biz.GetNoLogAsync(id);
            if (o == null)
                return NotFound(new ApiErrorResponse(ApiErrorCode.NOT_FOUND));

            if (!Authorized.IsAuthorizedToDelete(HttpContext.Items, biz.BizType, o.OwnerId))
                return StatusCode(401, new ApiNotAuthorizedResponse());

            if (!biz.Delete(o))
                return BadRequest(new ApiErrorResponse(biz.Errors));

            return NoContent();
        }


        /// <summary>
        /// Get route that triggers exception for testing
        /// </summary>
        /// <returns>Nothing, triggers exception</returns>
        [HttpGet("exception")]
        public ActionResult GetException()
        {
            if (!serverState.IsOpen)
                return StatusCode(503, new ApiErrorResponse(ApiErrorCode.API_CLOSED, null, serverState.Reason));
            throw new System.NotSupportedException("Test exception from widget controller");
        }

        /// <summary>
        /// Get route that triggers an alternate type of exception for testing
        /// </summary>
        /// <returns>Nothing, triggers exception</returns>
        [HttpGet("altexception")]
        public ActionResult GetAltException()
        {
            if (!serverState.IsOpen)
                return StatusCode(503, new ApiErrorResponse(ApiErrorCode.API_CLOSED, null, serverState.Reason));
            throw new System.ArgumentException("Test exception (ALT) from widget controller");
        }


        /// <summary>
        /// Get route that submits a simulated long running operation job for testing
        /// </summary>
        /// <returns>Nothing</returns>
        [HttpGet("TestWidgetJob")]
        public ActionResult TestWidgetJob()
        {
            if (!serverState.IsOpen)
                return StatusCode(503, new ApiErrorResponse(ApiErrorCode.API_CLOSED, null, serverState.Reason));

            if (!Authorized.IsAuthorizedToModify(HttpContext.Items, AyaType.JobOperations))
                return StatusCode(401, new ApiNotAuthorizedResponse());

            //Create the job here
            OpsJob j = new OpsJob();
            j.Name = "TestWidgetJob";
            j.JobType = JobType.TestWidgetJob;
            JobsBiz.AddJob(j, ct);
            return Accepted(new { JobId = j.GId });//202 accepted
        }

        //------------


    }//eoc
}//eons